#include<stdio.h>
#include<stdlib.h>
main()
{
	int N,O,A,B,AB;
	scanf("%d",&N);
	scanf("%d %d %d %d",&O,&A,&B,&AB);
	char c[N];
	int a[N];
	int O1,A1,B1,AB1;
	for(int i=0;i<N;i++)
	{
		scanf("%c %d",&c[i],&a[i]);
		if(c[i]=='O')O1+=a[i];
		if(c[i]=='A')A1+=a[i];
		if(c[i]=='B')B1+=a[i];
		if(c[i]=='AB')AB1+=a[i];
	}
	
	if(O1>O){
	printf("nemoguce");return 0;}
	if(A1>O+A){
	printf("nemoguce");return 0;}
	if(B1>O+B){
	printf("nemoguce");return 0;}
	if(AB1>O+A+B+AB1){
	printf("nemoguce");return 0;}
	/*
	int k=0;
	for(int i=0;i<N;i++)
	{
		if(c[i]=='O' && O>=a[i])O-=a[i];
		else {
			printf("nemoguce");return 0;
		}
	}
	for(int i=0;i<N;i++)
	{
		if(c[i]=='A' && A+O>=a[i]){
			if(A>=a[i])
			{
				A=A-a[i];
			}
			else
			{
				int temp=a[i]-A;
				A=0;
				O=O-temp;
			}
		}
		else {
			printf("nemoguce");return 0;
		}
	}
	for(int i=0;i<N;i++)
	{
		if(c[i]=='B' && B+O>=a[i]){
			if(B>=a[i])
			{
				B=B-a[i];
			}
			else
			{
				int temp=a[i]-B;
				B=0;
				O=O-temp;
			}
		}
		else {
			printf("nemoguce");return 0;
		}
	}
	for(int i=0;i<N;i++)
	{
		if(c[i]=='AB' && AB+A+B+O>=a[i]){
			if(AB>=a[i])
			{
				AB=AB-a[i];
			}
			else
			{
				int temp=a[i]-AB;
				AB=0;
				if(B>=temp)
				{
					B=B-temp;
				}
				else
				{
					int temp2=temp-B;
					B=0;
					if(A>=temp2)
					{
						A=A-temp2;
					}
					else
					{
						int temp3=temp2-A;
						A=0;
						O=O-temp3;
					}
				}
			}
		}
		else {
			printf("nemoguce");return 0;
		}
	}
	printf("moguce");*/
}